//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2009, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_minimum -1.1
#property indicator_maximum 1.1
#property indicator_buffers 1
#property indicator_color1 Lime

extern int Fast = 5;
extern int Slow = 21;
extern int Angle = 5;
extern int NoPic = 0;
extern int PriceMode=0;
double Trigger[];
double buf1[];
double buf2[];
double buf3[];
double gh;
int ar1[];
int ar2[];
int time=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Buf(int bar)
  {
   int jj;
   int j;
   int ap;
   int am;
   double rr;
   buf1[bar]=iMA(NULL,0,Fast+1,0,MODE_LWMA,PriceMode,bar);
   for(int i=bar+Fast-NoPic;i>bar;i--)
     {
      rr= 0.0;
      jj= 0;
      j = 0;
      ap = i + Fast;
      am = i - Fast;
      if(am<bar) am=bar;
      while(ap>=i)
        {
         j++;
         rr+= j * SPrice(ap);
         jj+= j;
         ap--;
        }
      while(ap>=am)
        {
         j--;
         rr+= j * SPrice(ap);
         jj+= j;
         ap--;
        }
      buf1[i]=rr/jj;
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double SPrice(int bar)
  {
   switch(PriceMode)
     {
      case PRICE_CLOSE:    return(Close[bar]);
      case PRICE_OPEN:     return(Open[bar]);
      case PRICE_HIGH:     return(High[bar]);
      case PRICE_LOW:      return(Low[bar]);
      case PRICE_MEDIAN:   return((High[bar]+Low[bar])/2.0);
      case PRICE_TYPICAL:  return((Close[bar]+High[bar]+Low[bar])/3.0);
      case PRICE_WEIGHTED: return((2.0*Close[bar]+High[bar]+Low[bar])/4.0);
     }
   return(Close[bar]);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SmoothOverMart(int bar)
  {
   double smax=buf1[ArrayMaximum(buf1,Slow,bar)];
   double smin=buf1[ArrayMinimum(buf1,Slow,bar)];
   buf2[bar]=(4.0*buf1[bar]-(smax+smin))/2.0;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Correlation(double in[],int bb)
  {
   double mp;
   for(int i=0;i<bb;i++) mp+=MathPow(in[i]-i-1.0,2);
   double res=1-6.0*mp/(MathPow(bb,3)-bb);
   return(res);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RankPrices(int aia_0[])
  {
   double aaa;
   double bbb;
   int ra;
   int rb;
   int rc;
   int rd;
   double rpm[];
   ArrayResize(rpm,Angle);
   ArrayCopy(ar2,aia_0);
   for(int i=0;i<Angle;i++) rpm[i]=i+1;
   ArraySort(ar2,WHOLE_ARRAY,0,MODE_DESCEND);
   for(i=0;i<Angle-1;i++)
     {
      if(ar2[i]==ar2[i+1])
        {
         rb=ar2[i];
         ra=i+1;
         rc= 1;
         bbb=i+1;
         while(ra<Angle)
           {
            if(ar2[ra]!=rb) break;
            rc++;
            bbb+=ra+1;
            ra++;
           }
         aaa=rc;
         bbb/=aaa;
         for(int m=i;m<ra;m++) rpm[m]=bbb;
         i=ra;
        }
     }
   for(i=0;i<Angle;i++)
     {
      rd=aia_0[i];
      for(ra=0;ra<Angle;ra++)
        {
         if(rd==ar2[ra])
           {
            buf3[i]=rpm[ra];
            break;
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
   SetIndexBuffer(0,Trigger);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,buf1);
   SetIndexStyle(1,DRAW_NONE);
   SetIndexBuffer(2,buf2);
   SetIndexStyle(2,DRAW_NONE);
   ArrayResize(buf3,Angle);
   ArrayResize(ar1,Angle);
   ArrayResize(ar2,Angle);
   IndicatorShortName("Trigger");
   gh=MathPow(10,Digits);
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int j;
   int ap;
   int am;
   int c_b;
   c_b=IndicatorCounted();
   if(Angle>30) return(-1);
   if(c_b==0)
     {
      j=Bars -(Angle+Slow+Fast+4);
      ap = Bars - (Fast + 2);
      am = Bars - (Slow + Fast + 3);
     }
   if(c_b>0)
     {
      if(FirstTickInBar()) j=MathMin(Bars-c_b+1,Bars -(Angle+Slow+Fast+4));
      else j=Bars-c_b+1;
      ap = j;
      am = j;
     }
   for(int i=ap;i>=0;i--) Buf(i);
   for(i=am;i>=0;i--) SmoothOverMart(i);
   for(i=j;i>=0;i--)
     {
      for(int jj=0;jj<Angle;jj++) ar1[jj]=MathRound((buf2[i+jj])*gh);
      RankPrices(ar1);
      Trigger[i]=Correlation(buf3,Angle);
      if(Trigger[i]>1.0) Trigger[i]=1.0;
      if(Trigger[i]<-1.0) Trigger[i]=-1.0;
     }
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool FirstTickInBar()
  {
   if(time==Time[0]) return(FALSE);
   time=Time[0];
   return(TRUE);
  }
//+------------------------------------------------------------------+
